/*
 * disp.h
 *
 * Created: 11.04.2017 11:22:55
 *  Author: dsosnowski
 */ 


#ifndef DISP_H_
#define DISP_H_


#define DISPLAY_PORT			PORTD		//active LO
#define DISPLAY_DDR				DDRD
#define SEG_A_PIN				7
#define SEG_B_PIN				5
#define SEG_C_PIN				1
#define SEG_D_PIN				3
#define SEG_E_PIN				2
#define SEG_F_PIN				6
#define SEG_G_PIN				0
#define SEG_DP_PIN				4

/*
	AAA
  F		B
  F		B
	GGG
  E		C
  E		C
	DDD	  DP
*/

#define DIGIT_0					(1<<SEG_A_PIN | 1<<SEG_B_PIN | 1<<SEG_C_PIN | 1<<SEG_D_PIN | 1<<SEG_E_PIN | 1<<SEG_F_PIN)
#define DIGIT_1					(1<<SEG_B_PIN | 1<<SEG_C_PIN)
#define DIGIT_2					(1<<SEG_A_PIN | 1<<SEG_B_PIN | 1<<SEG_G_PIN | 1<<SEG_E_PIN | 1<<SEG_D_PIN)
#define DIGIT_3					(1<<SEG_A_PIN | 1<<SEG_D_PIN | 1<<SEG_C_PIN | 1<<SEG_B_PIN | 1<<SEG_G_PIN)
#define DIGIT_4					(1<<SEG_B_PIN | 1<<SEG_C_PIN | 1<<SEG_F_PIN | 1<<SEG_G_PIN)
#define DIGIT_5					(1<<SEG_A_PIN | 1<<SEG_F_PIN | 1<<SEG_G_PIN | 1<<SEG_C_PIN | 1<<SEG_D_PIN)
#define DIGIT_6					(1<<SEG_A_PIN | 1<<SEG_F_PIN | 1<<SEG_E_PIN | 1<<SEG_D_PIN | 1<<SEG_C_PIN | 1<<SEG_G_PIN)
#define DIGIT_7					(1<<SEG_A_PIN | 1<<SEG_B_PIN | 1<<SEG_C_PIN | 1<<SEG_F_PIN)
#define DIGIT_8					(1<<SEG_A_PIN | 1<<SEG_B_PIN | 1<<SEG_C_PIN | 1<<SEG_D_PIN | 1<<SEG_E_PIN | 1<<SEG_F_PIN | 1<<SEG_G_PIN)
#define DIGIT_9					(1<<SEG_A_PIN | 1<<SEG_B_PIN | 1<<SEG_C_PIN | 1<<SEG_D_PIN | 1<<SEG_F_PIN | 1<<SEG_G_PIN)
#define DIGIT_NULL				0
#define DIGIT_MINUS				(1<<SEG_G_PIN)
#define DIGIT_DOT				(1<<SEG_DP_PIN)
#define DIGIT_POS				(1<<SEG_D_PIN)

#define ANODE_PORT				PORTB		//active LO
#define ANODE_DDR				DDRB
#define ANODE1_PIN				2
#define ANODE2_PIN				1
#define ANODE3_PIN				0
//#define ANODE4_PIN				3
#define ANODE1_SET				(ANODE_PORT &= ~(1<<ANODE1_PIN))
#define ANODE1_OFF				(ANODE_PORT |= (1<<ANODE1_PIN))
#define ANODE2_SET				(ANODE_PORT &= ~(1<<ANODE2_PIN))
#define ANODE2_OFF				(ANODE_PORT |= (1<<ANODE2_PIN))
#define ANODE3_SET				(ANODE_PORT &= ~(1<<ANODE3_PIN))
#define ANODE3_OFF				(ANODE_PORT |= (1<<ANODE3_PIN))
//#define ANODE4_SET				(ANODE_PORT &= ~(1<<ANODE4_PIN))
//#define ANODE4_OFF				(ANODE_PORT |= (1<<ANODE4_PIN))

#define DISP_TIMER_DIV			256
#define DISP_REFRESH_FREQ		500
#define DISP_NUMBEROFDISP		3	
#define DISP_EMPTY_CYCLES		2
#define DISP_CYCLES				(DISP_NUMBEROFDISP + DISP_EMPTY_CYCLES)

#define DIGIT_NULL_INDEX		11
#define DIGIT_MINUS_INDEX		12
#define DIGIT_DOT_INDEX			13
#define DIGIT_POS_INDEX			14
#define DIGIT_INDEX_LEN			15

#define DIGIT_NULL_VAL			0xFF

void DispInit(void);
void DispTest(uint8_t i);
void DispDigitsSet(uint8_t d2, uint8_t d1, uint8_t d0, uint8_t dot);
void DispDigitSet(uint8_t d, uint8_t index);
void DispDotSet(uint8_t d);
void DispTemp(int16_t temp);

#endif /* DISP_H_ */